# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from mistapi.api_helper import APIHelper
from mistapi.configuration import Server
from mistapi.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from mistapi.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from mistapi.exceptions.api_exception import APIException
from mistapi.exceptions.api_v_1_invite_verify_401_error_exception import ApiV1InviteVerify401ErrorException
from mistapi.exceptions.api_v_1_invite_verify_403_error_exception import ApiV1InviteVerify403ErrorException
from mistapi.exceptions.api_v_1_invite_verify_404_error_exception import ApiV1InviteVerify404ErrorException


class AdminController(BaseController):

    """A Controller to access Endpoints in the mistapi API."""
    def __init__(self, config):
        super(AdminController, self).__init__(config)

    def verify_admin_invite(self,
                            token):
        """Does a POST request to /api/v1/invite/verify/{token}.

        **Note**: another call to ```GET /api/v1/self``` is required to see
        the new set of privileges

        Args:
            token (string): TODO: type description here.

        Returns:
            object: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/api/v1/invite/verify/{token}')
            .http_method(HttpMethodEnum.POST)
            .template_param(Parameter()
                            .key('token')
                            .value(token)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .local_error('400', 'The API endpoint exists but its syntax/payload is incorrect, detail may be given', APIException)
            .local_error('401', 'Unauthorized', ApiV1InviteVerify401ErrorException)
            .local_error('403', 'Permission Denied', ApiV1InviteVerify403ErrorException)
            .local_error('404', 'Not Found', ApiV1InviteVerify404ErrorException)
        ).execute()
