# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from mistapi.api_helper import APIHelper
from mistapi.configuration import Server
from mistapi.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from mistapi.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from mistapi.models.count import Count
from mistapi.models.wired_clients_search import WiredClientsSearch
from mistapi.exceptions.api_exception import APIException
from mistapi.exceptions.api_v_1_sites_wired_clients_count_401_error_exception import ApiV1SitesWiredClientsCount401ErrorException
from mistapi.exceptions.api_v_1_sites_wired_clients_count_403_error_exception import ApiV1SitesWiredClientsCount403ErrorException
from mistapi.exceptions.api_v_1_sites_wired_clients_count_404_error_exception import ApiV1SitesWiredClientsCount404ErrorException
from mistapi.exceptions.api_v_1_sites_wired_clients_search_401_error_exception import ApiV1SitesWiredClientsSearch401ErrorException
from mistapi.exceptions.api_v_1_sites_wired_clients_search_403_error_exception import ApiV1SitesWiredClientsSearch403ErrorException
from mistapi.exceptions.api_v_1_sites_wired_clients_search_404_error_exception import ApiV1SitesWiredClientsSearch404ErrorException


class SitesClientsWiredController(BaseController):

    """A Controller to access Endpoints in the mistapi API."""
    def __init__(self, config):
        super(SitesClientsWiredController, self).__init__(config)

    def count_site_wired_clients(self,
                                 site_id,
                                 distinct='mac',
                                 mac=None,
                                 device_mac=None,
                                 port_id=None,
                                 vlan=None,
                                 page=1,
                                 limit=100,
                                 start=0,
                                 end=0,
                                 duration='1d'):
        """Does a GET request to /api/v1/sites/{site_id}/wired_clients/count.

        Count by Distinct Attributes of Clients

        Args:
            site_id (uuid|string): TODO: type description here.
            distinct (Distinct23Enum, optional): TODO: type description here.
                Example: mac
            mac (string, optional): client mac
            device_mac (string, optional): device mac
            port_id (string, optional): port id
            vlan (string, optional): vlan
            page (int, optional): TODO: type description here. Example: 1
            limit (int, optional): TODO: type description here. Example: 100
            start (int, optional): TODO: type description here. Example: 0
            end (int, optional): TODO: type description here. Example: 0
            duration (string, optional): For historical stats and/or logs
                where time range is needed, you can specify the time range in
                a few different ways:   * ?start=1430000000&end=1430864000
                specify the start / end   * ?end=1430864000&duration=1d
                specify end time and duration   * ?duration=1d specify
                duration, end will be now() in seconds

        Returns:
            Count: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/api/v1/sites/{site_id}/wired_clients/count')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('site_id')
                            .value(site_id)
                            .should_encode(True))
            .query_param(Parameter()
                         .key('distinct')
                         .value(distinct))
            .query_param(Parameter()
                         .key('mac')
                         .value(mac))
            .query_param(Parameter()
                         .key('device_mac')
                         .value(device_mac))
            .query_param(Parameter()
                         .key('port_id')
                         .value(port_id))
            .query_param(Parameter()
                         .key('vlan')
                         .value(vlan))
            .query_param(Parameter()
                         .key('page')
                         .value(page))
            .query_param(Parameter()
                         .key('limit')
                         .value(limit))
            .query_param(Parameter()
                         .key('start')
                         .value(start))
            .query_param(Parameter()
                         .key('end')
                         .value(end))
            .query_param(Parameter()
                         .key('duration')
                         .value(duration))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(Count.from_dictionary)
            .local_error('400', 'The API endpoint exists but its syntax/payload is incorrect, detail may be given', APIException)
            .local_error('401', 'Unauthorized', ApiV1SitesWiredClientsCount401ErrorException)
            .local_error('403', 'Permission Denied', ApiV1SitesWiredClientsCount403ErrorException)
            .local_error('404', 'Not found. The API endpoint doesn\'t exist or resource doesn\'t exist', ApiV1SitesWiredClientsCount404ErrorException)
        ).execute()

    def search_site_wired_clients(self,
                                  site_id,
                                  device_mac=None,
                                  mac=None,
                                  ip=None,
                                  port_id=None,
                                  vlan=None,
                                  ip_address=None,
                                  manufacture=None,
                                  text=None,
                                  limit=100,
                                  start=0,
                                  end=0,
                                  duration='1d'):
        """Does a GET request to /api/v1/sites/{site_id}/wired_clients/search.

        Search Wired Clients

        Args:
            site_id (uuid|string): TODO: type description here.
            device_mac (string, optional): device mac
            mac (string, optional): client mac
            ip (string, optional): client ip
            port_id (string, optional): port id
            vlan (string, optional): vlan
            ip_address (string, optional): TODO: type description here.
            manufacture (string, optional): manufacture
            text (string, optional): single entry of hostname/mac
            limit (int, optional): TODO: type description here. Example: 100
            start (int, optional): TODO: type description here. Example: 0
            end (int, optional): TODO: type description here. Example: 0
            duration (string, optional): For historical stats and/or logs
                where time range is needed, you can specify the time range in
                a few different ways:   * ?start=1430000000&end=1430864000
                specify the start / end   * ?end=1430864000&duration=1d
                specify end time and duration   * ?duration=1d specify
                duration, end will be now() in seconds

        Returns:
            WiredClientsSearch: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/api/v1/sites/{site_id}/wired_clients/search')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('site_id')
                            .value(site_id)
                            .should_encode(True))
            .query_param(Parameter()
                         .key('device_mac')
                         .value(device_mac))
            .query_param(Parameter()
                         .key('mac')
                         .value(mac))
            .query_param(Parameter()
                         .key('ip')
                         .value(ip))
            .query_param(Parameter()
                         .key('port_id')
                         .value(port_id))
            .query_param(Parameter()
                         .key('vlan')
                         .value(vlan))
            .query_param(Parameter()
                         .key('ip address')
                         .value(ip_address))
            .query_param(Parameter()
                         .key('manufacture')
                         .value(manufacture))
            .query_param(Parameter()
                         .key('text')
                         .value(text))
            .query_param(Parameter()
                         .key('limit')
                         .value(limit))
            .query_param(Parameter()
                         .key('start')
                         .value(start))
            .query_param(Parameter()
                         .key('end')
                         .value(end))
            .query_param(Parameter()
                         .key('duration')
                         .value(duration))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(WiredClientsSearch.from_dictionary)
            .local_error('400', 'The API endpoint exists but its syntax/payload is incorrect, detail may be given', APIException)
            .local_error('401', 'Unauthorized', ApiV1SitesWiredClientsSearch401ErrorException)
            .local_error('403', 'Permission Denied', ApiV1SitesWiredClientsSearch403ErrorException)
            .local_error('404', 'Not found. The API endpoint doesn\'t exist or resource doesn\'t exist', ApiV1SitesWiredClientsSearch404ErrorException)
        ).execute()
