# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from mistapi.api_helper import APIHelper
from mistapi.configuration import Server
from mistapi.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from mistapi.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from mistapi.models.api_v_1_sites_mxtunnels_preempt_aps_response import ApiV1SitesMxtunnelsPreemptApsResponse
from mistapi.exceptions.api_exception import APIException
from mistapi.exceptions.api_v_1_sites_mxtunnels_preempt_aps_401_error_exception import ApiV1SitesMxtunnelsPreemptAps401ErrorException
from mistapi.exceptions.api_v_1_sites_mxtunnels_preempt_aps_403_error_exception import ApiV1SitesMxtunnelsPreemptAps403ErrorException
from mistapi.exceptions.api_v_1_sites_mxtunnels_preempt_aps_404_error_exception import ApiV1SitesMxtunnelsPreemptAps404ErrorException


class SitesMxTunnelsController(BaseController):

    """A Controller to access Endpoints in the mistapi API."""
    def __init__(self, config):
        super(SitesMxTunnelsController, self).__init__(config)

    def preempt_sites_mx_tunnel(self,
                                site_id,
                                mxtunnel_id):
        """Does a POST request to /api/v1/sites/{site_id}/mxtunnels/{mxtunnel_id}/preempt_aps.

        To preempt AP’s which are not connected to preferred peer to the
        preferred peer

        Args:
            site_id (string): TODO: type description here.
            mxtunnel_id (string): TODO: type description here.

        Returns:
            ApiV1SitesMxtunnelsPreemptApsResponse: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/api/v1/sites/{site_id}/mxtunnels/{mxtunnel_id}/preempt_aps')
            .http_method(HttpMethodEnum.POST)
            .template_param(Parameter()
                            .key('site_id')
                            .value(site_id)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('mxtunnel_id')
                            .value(mxtunnel_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(ApiV1SitesMxtunnelsPreemptApsResponse.from_dictionary)
            .local_error('400', 'The API endpoint exists but its syntax/payload is incorrect, detail may be given', APIException)
            .local_error('401', 'Unauthorized', ApiV1SitesMxtunnelsPreemptAps401ErrorException)
            .local_error('403', 'Permission Denied', ApiV1SitesMxtunnelsPreemptAps403ErrorException)
            .local_error('404', 'Not found. The API endpoint doesn\'t exist or resource doesn\'t exist', ApiV1SitesMxtunnelsPreemptAps404ErrorException)
        ).execute()
