# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""

from mistapi.api_helper import APIHelper
from mistapi.configuration import Server
from mistapi.controllers.base_controller import BaseController
from apimatic_core.request_builder import RequestBuilder
from apimatic_core.response_handler import ResponseHandler
from apimatic_core.types.parameter import Parameter
from mistapi.http.http_method_enum import HttpMethodEnum
from apimatic_core.authentication.multiple.single_auth import Single
from apimatic_core.authentication.multiple.and_auth_group import And
from apimatic_core.authentication.multiple.or_auth_group import Or
from mistapi.models.rssizone import Rssizone
from mistapi.exceptions.api_exception import APIException
from mistapi.exceptions.api_v_1_sites_rssizones_401_error_exception import ApiV1SitesRssizones401ErrorException
from mistapi.exceptions.api_v_1_sites_rssizones_403_error_exception import ApiV1SitesRssizones403ErrorException
from mistapi.exceptions.api_v_1_sites_rssizones_404_error_exception import ApiV1SitesRssizones404ErrorException


class SitesRssizonesController(BaseController):

    """A Controller to access Endpoints in the mistapi API."""
    def __init__(self, config):
        super(SitesRssizonesController, self).__init__(config)

    def list_site_rssi_zones(self,
                             site_id):
        """Does a GET request to /api/v1/sites/{site_id}/rssizones.

        Get List of Site RSSI Zone (RSSI-based)

        Args:
            site_id (uuid|string): TODO: type description here.

        Returns:
            list of Rssizone: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/api/v1/sites/{site_id}/rssizones')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('site_id')
                            .value(site_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(Rssizone.from_dictionary)
            .local_error('400', 'The API endpoint exists but its syntax/payload is incorrect, detail may be given', APIException)
            .local_error('401', 'Unauthorized', ApiV1SitesRssizones401ErrorException)
            .local_error('403', 'Permission Denied', ApiV1SitesRssizones403ErrorException)
            .local_error('404', 'Not found. The API endpoint doesn\'t exist or resource doesn\'t exist', ApiV1SitesRssizones404ErrorException)
        ).execute()

    def create_site_rssi_zone(self,
                              site_id,
                              body=None):
        """Does a POST request to /api/v1/sites/{site_id}/rssizones.

        Create RSSI Zone

        Args:
            site_id (uuid|string): TODO: type description here.
            body (Rssizone, optional): Request Body

        Returns:
            Rssizone: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/api/v1/sites/{site_id}/rssizones')
            .http_method(HttpMethodEnum.POST)
            .template_param(Parameter()
                            .key('site_id')
                            .value(site_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(Rssizone.from_dictionary)
            .local_error('400', 'The API endpoint exists but its syntax/payload is incorrect, detail may be given', APIException)
            .local_error('401', 'Unauthorized', ApiV1SitesRssizones401ErrorException)
            .local_error('403', 'Permission Denied', ApiV1SitesRssizones403ErrorException)
            .local_error('404', 'Not found. The API endpoint doesn\'t exist or resource doesn\'t exist', ApiV1SitesRssizones404ErrorException)
        ).execute()

    def delete_site_rssi_zone(self,
                              site_id,
                              rssizone_id):
        """Does a DELETE request to /api/v1/sites/{site_id}/rssizones/{rssizone_id}.

        Delete Site RSSI Zone

        Args:
            site_id (uuid|string): TODO: type description here.
            rssizone_id (uuid|string): TODO: type description here.

        Returns:
            object: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/api/v1/sites/{site_id}/rssizones/{rssizone_id}')
            .http_method(HttpMethodEnum.DELETE)
            .template_param(Parameter()
                            .key('site_id')
                            .value(site_id)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('rssizone_id')
                            .value(rssizone_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .local_error('400', 'The API endpoint exists but its syntax/payload is incorrect, detail may be given', APIException)
            .local_error('401', 'Unauthorized', ApiV1SitesRssizones401ErrorException)
            .local_error('403', 'Permission Denied', ApiV1SitesRssizones403ErrorException)
            .local_error('404', 'Not found. The API endpoint doesn\'t exist or resource doesn\'t exist', ApiV1SitesRssizones404ErrorException)
        ).execute()

    def get_site_rssi_zone(self,
                           site_id,
                           rssizone_id):
        """Does a GET request to /api/v1/sites/{site_id}/rssizones/{rssizone_id}.

        Get Site RSSI Zone details

        Args:
            site_id (uuid|string): TODO: type description here.
            rssizone_id (uuid|string): TODO: type description here.

        Returns:
            list of Rssizone: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/api/v1/sites/{site_id}/rssizones/{rssizone_id}')
            .http_method(HttpMethodEnum.GET)
            .template_param(Parameter()
                            .key('site_id')
                            .value(site_id)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('rssizone_id')
                            .value(rssizone_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(Rssizone.from_dictionary)
            .local_error('400', 'The API endpoint exists but its syntax/payload is incorrect, detail may be given', APIException)
            .local_error('401', 'Unauthorized', ApiV1SitesRssizones401ErrorException)
            .local_error('403', 'Permission Denied', ApiV1SitesRssizones403ErrorException)
            .local_error('404', 'Not found. The API endpoint doesn\'t exist or resource doesn\'t exist', ApiV1SitesRssizones404ErrorException)
        ).execute()

    def update_site_rssi_zone(self,
                              site_id,
                              rssizone_id,
                              body=None):
        """Does a PUT request to /api/v1/sites/{site_id}/rssizones/{rssizone_id}.

        Update Site RSSI Zone

        Args:
            site_id (uuid|string): TODO: type description here.
            rssizone_id (uuid|string): TODO: type description here.
            body (Rssizone, optional): Request Body

        Returns:
            Rssizone: Response from the API. OK

        Raises:
            APIException: When an error occurs while fetching the data from
                the remote API. This exception includes the HTTP Response
                code, an error message, and the HTTP body that was received in
                the request.

        """

        return super().new_api_call_builder.request(
            RequestBuilder().server(Server.DEFAULT)
            .path('/api/v1/sites/{site_id}/rssizones/{rssizone_id}')
            .http_method(HttpMethodEnum.PUT)
            .template_param(Parameter()
                            .key('site_id')
                            .value(site_id)
                            .should_encode(True))
            .template_param(Parameter()
                            .key('rssizone_id')
                            .value(rssizone_id)
                            .should_encode(True))
            .header_param(Parameter()
                          .key('Content-Type')
                          .value('application/json'))
            .body_param(Parameter()
                        .value(body))
            .header_param(Parameter()
                          .key('accept')
                          .value('application/json'))
            .body_serializer(APIHelper.json_serialize)
            .auth(Single('global'))
        ).response(
            ResponseHandler()
            .deserializer(APIHelper.json_deserialize)
            .deserialize_into(Rssizone.from_dictionary)
            .local_error('400', 'The API endpoint exists but its syntax/payload is incorrect, detail may be given', APIException)
            .local_error('401', 'Unauthorized', ApiV1SitesRssizones401ErrorException)
            .local_error('403', 'Permission Denied', ApiV1SitesRssizones403ErrorException)
            .local_error('404', 'Not found. The API endpoint doesn\'t exist or resource doesn\'t exist', ApiV1SitesRssizones404ErrorException)
        ).execute()
