# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper


class ApIotInput(object):

    """Implementation of the 'ap_iot_input' model.

    IoT Input AP settings

    Attributes:
        enabled (bool): whether to enable a pin
        name (string): optional; descriptive pin name
        pullup (PullupEnum): the type of pull-up the pin uses (internal,
            external, none), default none

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "enabled": 'enabled',
        "name": 'name',
        "pullup": 'pullup'
    }

    _optionals = [
        'enabled',
        'name',
        'pullup',
    ]

    def __init__(self,
                 enabled=False,
                 name=APIHelper.SKIP,
                 pullup=APIHelper.SKIP):
        """Constructor for the ApIotInput class"""

        # Initialize members of the class
        self.enabled = enabled 
        if name is not APIHelper.SKIP:
            self.name = name 
        if pullup is not APIHelper.SKIP:
            self.pullup = pullup 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        enabled = dictionary.get("enabled") if dictionary.get("enabled") else False
        name = dictionary.get("name") if dictionary.get("name") else APIHelper.SKIP
        pullup = dictionary.get("pullup") if dictionary.get("pullup") else APIHelper.SKIP
        # Return an object of this model
        return cls(enabled,
                   name,
                   pullup)
