# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper


class ApUsb(object):

    """Implementation of the 'ap_usb' model.

    USB AP settings
    Note: if native imagotag is enabled, BLE will be disabled automatically
    Note: legacy, new config moved to ESL Config.

    Attributes:
        cacert (string): only if `type`==`imagotag`
        channel (int): only if `type`==`imagotag` channel selection, not
            needed by default, required for manual channel override only
        enabled (bool): whether to enable any usb config
        host (string): only if `type`==`imagotag`
        port (int): only if `type`==`imagotag`
        mtype (Type3Enum): usb config type
        verify_cert (bool): only if `type`==`imagotag`, whether to turn on SSL
            verification
        vlan_id (int): only if `type`==`solum` or `type`==`hanshow`

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "cacert": 'cacert',
        "channel": 'channel',
        "enabled": 'enabled',
        "host": 'host',
        "port": 'port',
        "mtype": 'type',
        "verify_cert": 'verify_cert',
        "vlan_id": 'vlan_id'
    }

    _optionals = [
        'cacert',
        'channel',
        'enabled',
        'host',
        'port',
        'mtype',
        'verify_cert',
        'vlan_id',
    ]

    _nullables = [
        'cacert',
    ]

    def __init__(self,
                 cacert=APIHelper.SKIP,
                 channel=APIHelper.SKIP,
                 enabled=APIHelper.SKIP,
                 host=APIHelper.SKIP,
                 port=0,
                 mtype=APIHelper.SKIP,
                 verify_cert=APIHelper.SKIP,
                 vlan_id=1):
        """Constructor for the ApUsb class"""

        # Initialize members of the class
        if cacert is not APIHelper.SKIP:
            self.cacert = cacert 
        if channel is not APIHelper.SKIP:
            self.channel = channel 
        if enabled is not APIHelper.SKIP:
            self.enabled = enabled 
        if host is not APIHelper.SKIP:
            self.host = host 
        self.port = port 
        if mtype is not APIHelper.SKIP:
            self.mtype = mtype 
        if verify_cert is not APIHelper.SKIP:
            self.verify_cert = verify_cert 
        self.vlan_id = vlan_id 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        cacert = dictionary.get("cacert") if "cacert" in dictionary.keys() else APIHelper.SKIP
        channel = dictionary.get("channel") if dictionary.get("channel") else APIHelper.SKIP
        enabled = dictionary.get("enabled") if "enabled" in dictionary.keys() else APIHelper.SKIP
        host = dictionary.get("host") if dictionary.get("host") else APIHelper.SKIP
        port = dictionary.get("port") if dictionary.get("port") else 0
        mtype = dictionary.get("type") if dictionary.get("type") else APIHelper.SKIP
        verify_cert = dictionary.get("verify_cert") if "verify_cert" in dictionary.keys() else APIHelper.SKIP
        vlan_id = dictionary.get("vlan_id") if dictionary.get("vlan_id") else 1
        # Return an object of this model
        return cls(cacert,
                   channel,
                   enabled,
                   host,
                   port,
                   mtype,
                   verify_cert,
                   vlan_id)
