# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper


class AppLimit(object):

    """Implementation of the 'AppLimit' model.

    bandwidth limiting for apps (applies to up/down)

    Attributes:
        apps (object): map from app key to bandwidth in kbps. app key defined
            in Get Application List
        enabled (bool): TODO: type description here.
        wxtag_ids (object): map from wxtag_id of Hostname Wxlan Tags to
            bandwidth in kbps

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "apps": 'apps',
        "enabled": 'enabled',
        "wxtag_ids": 'wxtag_ids'
    }

    _optionals = [
        'apps',
        'enabled',
        'wxtag_ids',
    ]

    def __init__(self,
                 apps=APIHelper.SKIP,
                 enabled=APIHelper.SKIP,
                 wxtag_ids=APIHelper.SKIP):
        """Constructor for the AppLimit class"""

        # Initialize members of the class
        if apps is not APIHelper.SKIP:
            self.apps = apps 
        if enabled is not APIHelper.SKIP:
            self.enabled = enabled 
        if wxtag_ids is not APIHelper.SKIP:
            self.wxtag_ids = wxtag_ids 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        apps = dictionary.get("apps") if dictionary.get("apps") else APIHelper.SKIP
        enabled = dictionary.get("enabled") if "enabled" in dictionary.keys() else APIHelper.SKIP
        wxtag_ids = dictionary.get("wxtag_ids") if dictionary.get("wxtag_ids") else APIHelper.SKIP
        # Return an object of this model
        return cls(apps,
                   enabled,
                   wxtag_ids)
