# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper
from mistapi.models.counts import Counts


class DeviceUpgradeResponse(object):

    """Implementation of the 'device_upgrade_response' model.

    TODO: type model description here.

    Attributes:
        counts (Counts): TODO: type description here.
        current_phase (int): current canary or rrm phase in progress
        enable_p_2_p (bool): whether to allow local AP-to-AP FW upgrade
        force (bool): whether to force upgrade when requested version is same
            as running version
        id (uuid|string): unique id for the upgrade
        max_failure_percentage (int): percentage of failures allowed
        max_failures (list of int): number of failures allowed within a canary
            phase or serial rollout
        reboot_at (int): reboot start time in epoch
        start_time (float): firmware download start time in epoch
        status (StatusEnum): status upgrade is in
        strategy (Strategy1Enum): upgrade strategy
        target_version (string): version to upgrade to
        upgrade_plan (object): a dictionary of rrm phase number to devices
            part of that phase

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "id": 'id',
        "counts": 'counts',
        "current_phase": 'current_phase',
        "enable_p_2_p": 'enable_p2p',
        "force": 'force',
        "max_failure_percentage": 'max_failure_percentage',
        "max_failures": 'max_failures',
        "reboot_at": 'reboot_at',
        "start_time": 'start_time',
        "status": 'status',
        "strategy": 'strategy',
        "target_version": 'target_version',
        "upgrade_plan": 'upgrade_plan'
    }

    _optionals = [
        'counts',
        'current_phase',
        'enable_p_2_p',
        'force',
        'max_failure_percentage',
        'max_failures',
        'reboot_at',
        'start_time',
        'status',
        'strategy',
        'target_version',
        'upgrade_plan',
    ]

    def __init__(self,
                 id=None,
                 counts=APIHelper.SKIP,
                 current_phase=APIHelper.SKIP,
                 enable_p_2_p=APIHelper.SKIP,
                 force=APIHelper.SKIP,
                 max_failure_percentage=APIHelper.SKIP,
                 max_failures=APIHelper.SKIP,
                 reboot_at=APIHelper.SKIP,
                 start_time=APIHelper.SKIP,
                 status=APIHelper.SKIP,
                 strategy='big_bang',
                 target_version=APIHelper.SKIP,
                 upgrade_plan=APIHelper.SKIP):
        """Constructor for the DeviceUpgradeResponse class"""

        # Initialize members of the class
        if counts is not APIHelper.SKIP:
            self.counts = counts 
        if current_phase is not APIHelper.SKIP:
            self.current_phase = current_phase 
        if enable_p_2_p is not APIHelper.SKIP:
            self.enable_p_2_p = enable_p_2_p 
        if force is not APIHelper.SKIP:
            self.force = force 
        self.id = id 
        if max_failure_percentage is not APIHelper.SKIP:
            self.max_failure_percentage = max_failure_percentage 
        if max_failures is not APIHelper.SKIP:
            self.max_failures = max_failures 
        if reboot_at is not APIHelper.SKIP:
            self.reboot_at = reboot_at 
        if start_time is not APIHelper.SKIP:
            self.start_time = start_time 
        if status is not APIHelper.SKIP:
            self.status = status 
        self.strategy = strategy 
        if target_version is not APIHelper.SKIP:
            self.target_version = target_version 
        if upgrade_plan is not APIHelper.SKIP:
            self.upgrade_plan = upgrade_plan 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        id = dictionary.get("id") if dictionary.get("id") else None
        counts = Counts.from_dictionary(dictionary.get('counts')) if 'counts' in dictionary.keys() else APIHelper.SKIP
        current_phase = dictionary.get("current_phase") if dictionary.get("current_phase") else APIHelper.SKIP
        enable_p_2_p = dictionary.get("enable_p2p") if "enable_p2p" in dictionary.keys() else APIHelper.SKIP
        force = dictionary.get("force") if "force" in dictionary.keys() else APIHelper.SKIP
        max_failure_percentage = dictionary.get("max_failure_percentage") if dictionary.get("max_failure_percentage") else APIHelper.SKIP
        max_failures = dictionary.get("max_failures") if dictionary.get("max_failures") else APIHelper.SKIP
        reboot_at = dictionary.get("reboot_at") if dictionary.get("reboot_at") else APIHelper.SKIP
        start_time = dictionary.get("start_time") if dictionary.get("start_time") else APIHelper.SKIP
        status = dictionary.get("status") if dictionary.get("status") else APIHelper.SKIP
        strategy = dictionary.get("strategy") if dictionary.get("strategy") else 'big_bang'
        target_version = dictionary.get("target_version") if dictionary.get("target_version") else APIHelper.SKIP
        upgrade_plan = dictionary.get("upgrade_plan") if dictionary.get("upgrade_plan") else APIHelper.SKIP
        # Return an object of this model
        return cls(id,
                   counts,
                   current_phase,
                   enable_p_2_p,
                   force,
                   max_failure_percentage,
                   max_failures,
                   reboot_at,
                   start_time,
                   status,
                   strategy,
                   target_version,
                   upgrade_plan)
