# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper


class JunosIpConfig(object):

    """Implementation of the 'junos_ip_config' model.

    Junos IP Config

    Attributes:
        dns (list of string): TODO: type description here.
        dns_suffix (list of string): TODO: type description here.
        gateway (string): TODO: type description here.
        ip (string): TODO: type description here.
        netmask (string): used only if `subnet` is not specified in
            `networks`
        network (string): the network where this mgmt IP reside, this will be
            used as default network for outbound-ssh, dns, ntp, dns, tacplus,
            radius, syslog, snmp
        mtype (Type11Enum): TODO: type description here.
        use_mgmt_vrf (bool): for host-out traffic
            (NTP/TACPLUS/RADIUS/SYSLOG/SNMP)

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "dns": 'dns',
        "dns_suffix": 'dns_suffix',
        "gateway": 'gateway',
        "ip": 'ip',
        "netmask": 'netmask',
        "network": 'network',
        "mtype": 'type',
        "use_mgmt_vrf": 'use_mgmt_vrf'
    }

    _optionals = [
        'dns',
        'dns_suffix',
        'gateway',
        'ip',
        'netmask',
        'network',
        'mtype',
        'use_mgmt_vrf',
    ]

    def __init__(self,
                 dns=APIHelper.SKIP,
                 dns_suffix=APIHelper.SKIP,
                 gateway=APIHelper.SKIP,
                 ip=APIHelper.SKIP,
                 netmask=APIHelper.SKIP,
                 network=APIHelper.SKIP,
                 mtype='dynamic',
                 use_mgmt_vrf=False):
        """Constructor for the JunosIpConfig class"""

        # Initialize members of the class
        if dns is not APIHelper.SKIP:
            self.dns = dns 
        if dns_suffix is not APIHelper.SKIP:
            self.dns_suffix = dns_suffix 
        if gateway is not APIHelper.SKIP:
            self.gateway = gateway 
        if ip is not APIHelper.SKIP:
            self.ip = ip 
        if netmask is not APIHelper.SKIP:
            self.netmask = netmask 
        if network is not APIHelper.SKIP:
            self.network = network 
        self.mtype = mtype 
        self.use_mgmt_vrf = use_mgmt_vrf 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        dns = dictionary.get("dns") if dictionary.get("dns") else APIHelper.SKIP
        dns_suffix = dictionary.get("dns_suffix") if dictionary.get("dns_suffix") else APIHelper.SKIP
        gateway = dictionary.get("gateway") if dictionary.get("gateway") else APIHelper.SKIP
        ip = dictionary.get("ip") if dictionary.get("ip") else APIHelper.SKIP
        netmask = dictionary.get("netmask") if dictionary.get("netmask") else APIHelper.SKIP
        network = dictionary.get("network") if dictionary.get("network") else APIHelper.SKIP
        mtype = dictionary.get("type") if dictionary.get("type") else 'dynamic'
        use_mgmt_vrf = dictionary.get("use_mgmt_vrf") if dictionary.get("use_mgmt_vrf") else False
        # Return an object of this model
        return cls(dns,
                   dns_suffix,
                   gateway,
                   ip,
                   netmask,
                   network,
                   mtype,
                   use_mgmt_vrf)
