# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper


class Node1(object):

    """Implementation of the 'Node1' model.

    for HA Cluster, node1 can have different IP Config

    Attributes:
        ip (string): TODO: type description here.
        netmask (string): used only if `subnet` is not specified in
            `networks`
        network (string): optional, the network to be used for mgmt
        mtype (Type11Enum): TODO: type description here.
        use_mgmt_vrf (bool): if supported on the platform. If enabled, DNS
            will be using this routing-instance, too
        use_mgmt_vrf_for_host_out (bool): whether to use `mgmt_junos` for
            host-out traffic (NTP/TACPLUS/RADIUS/SYSLOG/SNMP), if alternative
            service is desired
        vlan_id (int): optional, if different from parent

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "ip": 'ip',
        "netmask": 'netmask',
        "network": 'network',
        "mtype": 'type',
        "use_mgmt_vrf": 'use_mgmt_vrf',
        "use_mgmt_vrf_for_host_out": 'use_mgmt_vrf_for_host_out',
        "vlan_id": 'vlan_id'
    }

    _optionals = [
        'ip',
        'netmask',
        'network',
        'mtype',
        'use_mgmt_vrf',
        'use_mgmt_vrf_for_host_out',
        'vlan_id',
    ]

    def __init__(self,
                 ip=APIHelper.SKIP,
                 netmask=APIHelper.SKIP,
                 network=APIHelper.SKIP,
                 mtype='dynamic',
                 use_mgmt_vrf=False,
                 use_mgmt_vrf_for_host_out=False,
                 vlan_id=APIHelper.SKIP):
        """Constructor for the Node1 class"""

        # Initialize members of the class
        if ip is not APIHelper.SKIP:
            self.ip = ip 
        if netmask is not APIHelper.SKIP:
            self.netmask = netmask 
        if network is not APIHelper.SKIP:
            self.network = network 
        self.mtype = mtype 
        self.use_mgmt_vrf = use_mgmt_vrf 
        self.use_mgmt_vrf_for_host_out = use_mgmt_vrf_for_host_out 
        if vlan_id is not APIHelper.SKIP:
            self.vlan_id = vlan_id 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        ip = dictionary.get("ip") if dictionary.get("ip") else APIHelper.SKIP
        netmask = dictionary.get("netmask") if dictionary.get("netmask") else APIHelper.SKIP
        network = dictionary.get("network") if dictionary.get("network") else APIHelper.SKIP
        mtype = dictionary.get("type") if dictionary.get("type") else 'dynamic'
        use_mgmt_vrf = dictionary.get("use_mgmt_vrf") if dictionary.get("use_mgmt_vrf") else False
        use_mgmt_vrf_for_host_out = dictionary.get("use_mgmt_vrf_for_host_out") if dictionary.get("use_mgmt_vrf_for_host_out") else False
        vlan_id = dictionary.get("vlan_id") if dictionary.get("vlan_id") else APIHelper.SKIP
        # Return an object of this model
        return cls(ip,
                   netmask,
                   network,
                   mtype,
                   use_mgmt_vrf,
                   use_mgmt_vrf_for_host_out,
                   vlan_id)
