# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper
from mistapi.models.network_connection import NetworkConnection


class StatsSdkclient(object):

    """Implementation of the 'stats_sdkclient' model.

    SDK Client statistics

    Attributes:
        id (uuid|string): TODO: type description here.
        last_seen (float): last seen timestamp
        map_id (uuid|string): map_id of the sdk client (if known), or null
        name (string): name of the sdk client (if provided)
        network_connection (NetworkConnection): various network connection
            info for the SDK client (if known, else omitted), with RSSI in
            dBm, and signal level as
        uuid (uuid|string): uuid of the sdk client
        x (float): x (in pixels) of user location on the map (if known)
        y (float): y (in pixels) of user location on the map (if known)

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "id": 'id',
        "last_seen": 'last_seen',
        "network_connection": 'network_connection',
        "uuid": 'uuid',
        "map_id": 'map_id',
        "name": 'name',
        "x": 'x',
        "y": 'y'
    }

    _optionals = [
        'map_id',
        'name',
        'x',
        'y',
    ]

    _nullables = [
        'map_id',
    ]

    def __init__(self,
                 id=None,
                 last_seen=None,
                 network_connection=None,
                 uuid=None,
                 map_id=APIHelper.SKIP,
                 name=APIHelper.SKIP,
                 x=APIHelper.SKIP,
                 y=APIHelper.SKIP):
        """Constructor for the StatsSdkclient class"""

        # Initialize members of the class
        self.id = id 
        self.last_seen = last_seen 
        if map_id is not APIHelper.SKIP:
            self.map_id = map_id 
        if name is not APIHelper.SKIP:
            self.name = name 
        self.network_connection = network_connection 
        self.uuid = uuid 
        if x is not APIHelper.SKIP:
            self.x = x 
        if y is not APIHelper.SKIP:
            self.y = y 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        id = dictionary.get("id") if dictionary.get("id") else None
        last_seen = dictionary.get("last_seen") if dictionary.get("last_seen") else None
        network_connection = NetworkConnection.from_dictionary(dictionary.get('network_connection')) if dictionary.get('network_connection') else None
        uuid = dictionary.get("uuid") if dictionary.get("uuid") else None
        map_id = dictionary.get("map_id") if "map_id" in dictionary.keys() else APIHelper.SKIP
        name = dictionary.get("name") if dictionary.get("name") else APIHelper.SKIP
        x = dictionary.get("x") if dictionary.get("x") else APIHelper.SKIP
        y = dictionary.get("y") if dictionary.get("y") else APIHelper.SKIP
        # Return an object of this model
        return cls(id,
                   last_seen,
                   network_connection,
                   uuid,
                   map_id,
                   name,
                   x,
                   y)
