# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper


class StatsSwitchPort(object):

    """Implementation of the 'stats_switch_port' model.

    Switch port statistics

    Attributes:
        for_site (bool): TODO: type description here.
        mac (string): TODO: type description here.
        neighbor_mac (string): chassis identifier of the chassis type listed
        neighbor_port_desc (string): description supplied by the system on the
            interface E.g. “GigabitEthernet2/0/39”
        neighbor_system_name (string): name supplied by the system on the
            interface E.g. neighbor system name E.g.
            “Kumar-Acc-SW.mist.local”
        org_id (uuid|string): TODO: type description here.
        poe_disabled (bool): is the POE configured not be disabled.
        port_id (string): TODO: type description here.
        port_mac (string): interface mac address
        rx_bytes (int): rx bytes
        rx_pkts (int): rx packets
        site_id (uuid|string): TODO: type description here.
        speed (int): port speed
        tx_bytes (int): tx bytes
        tx_pkts (int): tx packets
        up (bool): indicates if interface is up
        xcvr_part_number (string): TODO: type description here.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "mac": 'mac',
        "neighbor_mac": 'neighbor_mac',
        "org_id": 'org_id',
        "port_id": 'port_id',
        "port_mac": 'port_mac',
        "rx_bytes": 'rx_bytes',
        "rx_pkts": 'rx_pkts',
        "site_id": 'site_id',
        "tx_bytes": 'tx_bytes',
        "tx_pkts": 'tx_pkts',
        "for_site": 'for_site',
        "neighbor_port_desc": 'neighbor_port_desc',
        "neighbor_system_name": 'neighbor_system_name',
        "poe_disabled": 'poe_disabled',
        "speed": 'speed',
        "up": 'up',
        "xcvr_part_number": 'xcvr_part_number'
    }

    _optionals = [
        'for_site',
        'neighbor_port_desc',
        'neighbor_system_name',
        'poe_disabled',
        'speed',
        'up',
        'xcvr_part_number',
    ]

    def __init__(self,
                 mac=None,
                 neighbor_mac=None,
                 org_id=None,
                 port_id=None,
                 port_mac=None,
                 rx_bytes=None,
                 rx_pkts=None,
                 site_id=None,
                 tx_bytes=None,
                 tx_pkts=None,
                 for_site=APIHelper.SKIP,
                 neighbor_port_desc=APIHelper.SKIP,
                 neighbor_system_name=APIHelper.SKIP,
                 poe_disabled=APIHelper.SKIP,
                 speed=APIHelper.SKIP,
                 up=APIHelper.SKIP,
                 xcvr_part_number=APIHelper.SKIP):
        """Constructor for the StatsSwitchPort class"""

        # Initialize members of the class
        if for_site is not APIHelper.SKIP:
            self.for_site = for_site 
        self.mac = mac 
        self.neighbor_mac = neighbor_mac 
        if neighbor_port_desc is not APIHelper.SKIP:
            self.neighbor_port_desc = neighbor_port_desc 
        if neighbor_system_name is not APIHelper.SKIP:
            self.neighbor_system_name = neighbor_system_name 
        self.org_id = org_id 
        if poe_disabled is not APIHelper.SKIP:
            self.poe_disabled = poe_disabled 
        self.port_id = port_id 
        self.port_mac = port_mac 
        self.rx_bytes = rx_bytes 
        self.rx_pkts = rx_pkts 
        self.site_id = site_id 
        if speed is not APIHelper.SKIP:
            self.speed = speed 
        self.tx_bytes = tx_bytes 
        self.tx_pkts = tx_pkts 
        if up is not APIHelper.SKIP:
            self.up = up 
        if xcvr_part_number is not APIHelper.SKIP:
            self.xcvr_part_number = xcvr_part_number 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        mac = dictionary.get("mac") if dictionary.get("mac") else None
        neighbor_mac = dictionary.get("neighbor_mac") if dictionary.get("neighbor_mac") else None
        org_id = dictionary.get("org_id") if dictionary.get("org_id") else None
        port_id = dictionary.get("port_id") if dictionary.get("port_id") else None
        port_mac = dictionary.get("port_mac") if dictionary.get("port_mac") else None
        rx_bytes = dictionary.get("rx_bytes") if dictionary.get("rx_bytes") else None
        rx_pkts = dictionary.get("rx_pkts") if dictionary.get("rx_pkts") else None
        site_id = dictionary.get("site_id") if dictionary.get("site_id") else None
        tx_bytes = dictionary.get("tx_bytes") if dictionary.get("tx_bytes") else None
        tx_pkts = dictionary.get("tx_pkts") if dictionary.get("tx_pkts") else None
        for_site = dictionary.get("for_site") if "for_site" in dictionary.keys() else APIHelper.SKIP
        neighbor_port_desc = dictionary.get("neighbor_port_desc") if dictionary.get("neighbor_port_desc") else APIHelper.SKIP
        neighbor_system_name = dictionary.get("neighbor_system_name") if dictionary.get("neighbor_system_name") else APIHelper.SKIP
        poe_disabled = dictionary.get("poe_disabled") if "poe_disabled" in dictionary.keys() else APIHelper.SKIP
        speed = dictionary.get("speed") if dictionary.get("speed") else APIHelper.SKIP
        up = dictionary.get("up") if "up" in dictionary.keys() else APIHelper.SKIP
        xcvr_part_number = dictionary.get("xcvr_part_number") if dictionary.get("xcvr_part_number") else APIHelper.SKIP
        # Return an object of this model
        return cls(mac,
                   neighbor_mac,
                   org_id,
                   port_id,
                   port_mac,
                   rx_bytes,
                   rx_pkts,
                   site_id,
                   tx_bytes,
                   tx_pkts,
                   for_site,
                   neighbor_port_desc,
                   neighbor_system_name,
                   poe_disabled,
                   speed,
                   up,
                   xcvr_part_number)
