# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper


class StatsUnconnectedClients(object):

    """Implementation of the 'stats_unconnected_clients' model.

    Unconnected clients statistics

    Attributes:
        ap_mac (string): mac address of the AP that heard the client
        last_seen (float): last seen timestamp
        mac (string): mac address of the (unconnected) client
        manufacture (string): device manufacture, through fingerprinting or
            OUI
        map_id (uuid|string): map_id of the client (if known), or null
        rssi (int): client RSSI observered by the AP that heard the client (in
            dBm)
        x (int): x (in pixels) of user location on the map (if known)
        y (int): y (in pixels) of user location on the map (if known)

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "ap_mac": 'ap_mac',
        "last_seen": 'last_seen',
        "mac": 'mac',
        "manufacture": 'manufacture',
        "rssi": 'rssi',
        "y": 'y',
        "map_id": 'map_id',
        "x": 'x'
    }

    _optionals = [
        'map_id',
        'x',
    ]

    _nullables = [
        'map_id',
    ]

    def __init__(self,
                 ap_mac=None,
                 last_seen=None,
                 mac=None,
                 manufacture=None,
                 rssi=None,
                 y=None,
                 map_id=APIHelper.SKIP,
                 x=APIHelper.SKIP):
        """Constructor for the StatsUnconnectedClients class"""

        # Initialize members of the class
        self.ap_mac = ap_mac 
        self.last_seen = last_seen 
        self.mac = mac 
        self.manufacture = manufacture 
        if map_id is not APIHelper.SKIP:
            self.map_id = map_id 
        self.rssi = rssi 
        if x is not APIHelper.SKIP:
            self.x = x 
        self.y = y 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        ap_mac = dictionary.get("ap_mac") if dictionary.get("ap_mac") else None
        last_seen = dictionary.get("last_seen") if dictionary.get("last_seen") else None
        mac = dictionary.get("mac") if dictionary.get("mac") else None
        manufacture = dictionary.get("manufacture") if dictionary.get("manufacture") else None
        rssi = dictionary.get("rssi") if dictionary.get("rssi") else None
        y = dictionary.get("y") if dictionary.get("y") else None
        map_id = dictionary.get("map_id") if "map_id" in dictionary.keys() else APIHelper.SKIP
        x = dictionary.get("x") if dictionary.get("x") else APIHelper.SKIP
        # Return an object of this model
        return cls(ap_mac,
                   last_seen,
                   mac,
                   manufacture,
                   rssi,
                   y,
                   map_id,
                   x)
