# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper
from mistapi.models.assets_waits import AssetsWaits
from mistapi.models.clients_waits import ClientsWaits
from mistapi.models.sdkclients_waits import SdkclientsWaits


class StatsZone(object):

    """Implementation of the 'stats_zone' model.

    Zone statistics

    Attributes:
        assets_waits (AssetsWaits): ble asset wait time right now
        clients_waits (ClientsWaits): client wait time right now
        created_time (int): TODO: type description here.
        id (uuid|string): id of the zone
        map_id (uuid|string): map_id of the zone
        modified_time (int): TODO: type description here.
        name (string): name of the zone
        num_assets (int): number of assets
        num_clients (int): number of wifi clients (unconnected + connected)
        num_sdkclients (int): number of sdk clients
        occupancy_limit (int): TODO: type description here.
        org_id (string): TODO: type description here.
        sdkclients_waits (SdkclientsWaits): sdkclient wait time right now
        site_id (string): TODO: type description here.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "id": 'id',
        "map_id": 'map_id',
        "name": 'name',
        "assets_waits": 'assets_waits',
        "clients_waits": 'clients_waits',
        "created_time": 'created_time',
        "modified_time": 'modified_time',
        "num_assets": 'num_assets',
        "num_clients": 'num_clients',
        "num_sdkclients": 'num_sdkclients',
        "occupancy_limit": 'occupancy_limit',
        "org_id": 'org_id',
        "sdkclients_waits": 'sdkclients_waits',
        "site_id": 'site_id'
    }

    _optionals = [
        'assets_waits',
        'clients_waits',
        'created_time',
        'modified_time',
        'num_assets',
        'num_clients',
        'num_sdkclients',
        'occupancy_limit',
        'org_id',
        'sdkclients_waits',
        'site_id',
    ]

    def __init__(self,
                 id=None,
                 map_id=None,
                 name=None,
                 assets_waits=APIHelper.SKIP,
                 clients_waits=APIHelper.SKIP,
                 created_time=APIHelper.SKIP,
                 modified_time=APIHelper.SKIP,
                 num_assets=APIHelper.SKIP,
                 num_clients=APIHelper.SKIP,
                 num_sdkclients=APIHelper.SKIP,
                 occupancy_limit=APIHelper.SKIP,
                 org_id=APIHelper.SKIP,
                 sdkclients_waits=APIHelper.SKIP,
                 site_id=APIHelper.SKIP):
        """Constructor for the StatsZone class"""

        # Initialize members of the class
        if assets_waits is not APIHelper.SKIP:
            self.assets_waits = assets_waits 
        if clients_waits is not APIHelper.SKIP:
            self.clients_waits = clients_waits 
        if created_time is not APIHelper.SKIP:
            self.created_time = created_time 
        self.id = id 
        self.map_id = map_id 
        if modified_time is not APIHelper.SKIP:
            self.modified_time = modified_time 
        self.name = name 
        if num_assets is not APIHelper.SKIP:
            self.num_assets = num_assets 
        if num_clients is not APIHelper.SKIP:
            self.num_clients = num_clients 
        if num_sdkclients is not APIHelper.SKIP:
            self.num_sdkclients = num_sdkclients 
        if occupancy_limit is not APIHelper.SKIP:
            self.occupancy_limit = occupancy_limit 
        if org_id is not APIHelper.SKIP:
            self.org_id = org_id 
        if sdkclients_waits is not APIHelper.SKIP:
            self.sdkclients_waits = sdkclients_waits 
        if site_id is not APIHelper.SKIP:
            self.site_id = site_id 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        id = dictionary.get("id") if dictionary.get("id") else None
        map_id = dictionary.get("map_id") if dictionary.get("map_id") else None
        name = dictionary.get("name") if dictionary.get("name") else None
        assets_waits = AssetsWaits.from_dictionary(dictionary.get('assets_waits')) if 'assets_waits' in dictionary.keys() else APIHelper.SKIP
        clients_waits = ClientsWaits.from_dictionary(dictionary.get('clients_waits')) if 'clients_waits' in dictionary.keys() else APIHelper.SKIP
        created_time = dictionary.get("created_time") if dictionary.get("created_time") else APIHelper.SKIP
        modified_time = dictionary.get("modified_time") if dictionary.get("modified_time") else APIHelper.SKIP
        num_assets = dictionary.get("num_assets") if dictionary.get("num_assets") else APIHelper.SKIP
        num_clients = dictionary.get("num_clients") if dictionary.get("num_clients") else APIHelper.SKIP
        num_sdkclients = dictionary.get("num_sdkclients") if dictionary.get("num_sdkclients") else APIHelper.SKIP
        occupancy_limit = dictionary.get("occupancy_limit") if dictionary.get("occupancy_limit") else APIHelper.SKIP
        org_id = dictionary.get("org_id") if dictionary.get("org_id") else APIHelper.SKIP
        sdkclients_waits = SdkclientsWaits.from_dictionary(dictionary.get('sdkclients_waits')) if 'sdkclients_waits' in dictionary.keys() else APIHelper.SKIP
        site_id = dictionary.get("site_id") if dictionary.get("site_id") else APIHelper.SKIP
        # Return an object of this model
        return cls(id,
                   map_id,
                   name,
                   assets_waits,
                   clients_waits,
                   created_time,
                   modified_time,
                   num_assets,
                   num_clients,
                   num_sdkclients,
                   occupancy_limit,
                   org_id,
                   sdkclients_waits,
                   site_id)
