# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper


class Targets(object):

    """Implementation of the 'Targets' model.

    TODO: type model description here.

    Attributes:
        downloaded (list of uuid|string): devices which have the firmware
            downloaded
        failed (list of uuid|string): devices which have the failed to
            upgrade
        reboot_in_progress (list of uuid|string): devices which are rebooting
        rebooted (list of uuid|string): devices which have rebooted
            successfully
        scheduled (list of uuid|string): devices which cloud has scheduled an
            upgrade
        skipped (list of uuid|string): devices which have skipped upgrade
            since requested version was same as running version. Use `force`
            to always upgrade
        upgraded (list of uuid|string): devices which have upgraded
            successfully

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "downloaded": 'downloaded',
        "failed": 'failed',
        "reboot_in_progress": 'reboot_in_progress',
        "rebooted": 'rebooted',
        "scheduled": 'scheduled',
        "skipped": 'skipped',
        "upgraded": 'upgraded'
    }

    _optionals = [
        'downloaded',
        'failed',
        'reboot_in_progress',
        'rebooted',
        'scheduled',
        'skipped',
        'upgraded',
    ]

    def __init__(self,
                 downloaded=APIHelper.SKIP,
                 failed=APIHelper.SKIP,
                 reboot_in_progress=APIHelper.SKIP,
                 rebooted=APIHelper.SKIP,
                 scheduled=APIHelper.SKIP,
                 skipped=APIHelper.SKIP,
                 upgraded=APIHelper.SKIP):
        """Constructor for the Targets class"""

        # Initialize members of the class
        if downloaded is not APIHelper.SKIP:
            self.downloaded = downloaded 
        if failed is not APIHelper.SKIP:
            self.failed = failed 
        if reboot_in_progress is not APIHelper.SKIP:
            self.reboot_in_progress = reboot_in_progress 
        if rebooted is not APIHelper.SKIP:
            self.rebooted = rebooted 
        if scheduled is not APIHelper.SKIP:
            self.scheduled = scheduled 
        if skipped is not APIHelper.SKIP:
            self.skipped = skipped 
        if upgraded is not APIHelper.SKIP:
            self.upgraded = upgraded 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        downloaded = dictionary.get("downloaded") if dictionary.get("downloaded") else APIHelper.SKIP
        failed = dictionary.get("failed") if dictionary.get("failed") else APIHelper.SKIP
        reboot_in_progress = dictionary.get("reboot_in_progress") if dictionary.get("reboot_in_progress") else APIHelper.SKIP
        rebooted = dictionary.get("rebooted") if dictionary.get("rebooted") else APIHelper.SKIP
        scheduled = dictionary.get("scheduled") if dictionary.get("scheduled") else APIHelper.SKIP
        skipped = dictionary.get("skipped") if dictionary.get("skipped") else APIHelper.SKIP
        upgraded = dictionary.get("upgraded") if dictionary.get("upgraded") else APIHelper.SKIP
        # Return an object of this model
        return cls(downloaded,
                   failed,
                   reboot_in_progress,
                   rebooted,
                   scheduled,
                   skipped,
                   upgraded)
