# -*- coding: utf-8 -*-

"""
mistapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from mistapi.api_helper import APIHelper
from mistapi.models.member import Member


class VirtualChassis(object):

    """Implementation of the 'VirtualChassis' model.

    required for preprovisioned Virtual Chassis

    Attributes:
        members (list of Member): list of Virtual Chassis mem
        preprovisioned (bool): to configure whether the VC is preprovisioned
            or nonprovisioned

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "members": 'members',
        "preprovisioned": 'preprovisioned'
    }

    _optionals = [
        'members',
        'preprovisioned',
    ]

    def __init__(self,
                 members=APIHelper.SKIP,
                 preprovisioned=False):
        """Constructor for the VirtualChassis class"""

        # Initialize members of the class
        if members is not APIHelper.SKIP:
            self.members = members 
        self.preprovisioned = preprovisioned 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """
        if dictionary is None:
            return None

        # Extract variables from the dictionary

        members = None
        if dictionary.get('members') is not None:
            members = [Member.from_dictionary(x) for x in dictionary.get('members')]
        else:
            members = APIHelper.SKIP
        preprovisioned = dictionary.get("preprovisioned") if dictionary.get("preprovisioned") else False
        # Return an object of this model
        return cls(members,
                   preprovisioned)
